redi::pstream_common< CharT, Traits >(3)

NAME
redi::pstream_common - Class template for common base class

SYNOPSIS

#include <pstream.h>

Inherits basic_ios< CharT, std::char_traits< CharT > >, and redi::pstreams.

  Public Types

typedef int fd_type
Type used for file descriptors.

  Public Member Functions

int close ()
bool is_open () const
Report whether the stream's buffer has been initialised.
const std::string & command () const
Return the command used to initialise the stream.
streambuf_type * rdbuf () const
Return a pointer to the stream buffer.

  Static Public Attributes

static const pmode pstdin = std::ios_base::out
Write to stdin.
static const pmode pstdout = std::ios_base::in
Read from stdout.
static const pmode pstderr = std::ios_base::app
Read from stderr.
static const pmode newpg = std::ios_base::trunc
Create a new process group for the child process.

  Protected Types

typedef basic_pstreambuf< CharT, Traits > streambuf_type
typedef std::basic_ios< CharT, Traits > ios_type
typedef pstreams::pmode pmode
typedef pstreams::argv_type argv_type
enum { bufsz = 32 }
enum { pbsz = 2 }

  Protected Member Functions

pstream_common ()
Default constructor.
pstream_common (const std::string &cmd, pmode mode)
Constructor that initialises the stream by starting a process.
pstream_common (const std::string &file, const argv_type &argv, pmode mode)
Constructor that initialises the stream by starting a process.
virtual ~pstream_common ()=0
Pure virtual destructor.
void do_open (const std::string &cmd, pmode mode)
Start a process.
void do_open (const std::string &file, const argv_type &argv, pmode mode)
Start a process.

  Protected Attributes

std::string command_
The command used to start the process.
streambuf_type buf_
The stream buffer.

Detailed Description

  template<typename CharT, typename Traits = std::char_traits<CharT>>
class redi::pstream_common< CharT, Traits >" Class template for common base class.

Abstract Base Class providing common functionality for basic_ipstream, basic_opstream and basic_pstream. pstream_common manages the basic_pstreambuf stream buffer that is used by the derived classes to initialise an iostream class.

Constructor & Destructor Documentation

  template<typename C , typename T > redi::pstream_common< C, T >::pstream_common [inline], [protected]

Default constructor. Creates an uninitialised stream.

References redi::pstream_common< CharT, Traits >::buf_.

  template<typename C , typename T > redi::pstream_common< C, T >::pstream_common (const std::string & cmd, pmode mode) [inline], [protected]

Constructor that initialises the stream by starting a process. Initialises the stream buffer by calling do_open( command , mode )

Parameters
    cmd a string containing a shell command.
    mode the I/O mode to use when opening the pipe.

See also
    do_open(const std::string&, pmode)

References redi::pstream_common< CharT, Traits >::buf_, and redi::pstream_common< CharT, Traits >::do_open().

  template<typename C , typename T > redi::pstream_common< C, T >::pstream_common (const std::string & file, const argv_type & argv, pmode mode) [inline], [protected]

Constructor that initialises the stream by starting a process. Initialises the stream buffer by calling do_open( file , argv , mode )

Parameters
    file a string containing the pathname of a program to execute.
    argv a vector of argument strings passed to the new program.
    mode the I/O mode to use when opening the pipe.

See also
    do_open(const std::string&, const argv_type&, pmode)

References redi::pstream_common< CharT, Traits >::buf_, and redi::pstream_common< CharT, Traits >::do_open().

  template<typename C , typename T > redi::pstream_common< C, T >::~pstream_common [inline], [protected], [pure virtual]

Pure virtual destructor. This is a pure virtual function to make pstream_common abstract. Because it is the destructor it will be called by derived classes and so must be defined. It is also protected, to discourage use of the PStreams classes through pointers or references to the base class.

See also
    If defining a pure virtual seems odd you should read http://www.gotw.ca/gotw/031.htm (and the rest of the site as well!)

Member Function Documentation

  template<typename C , typename T > int redi::pstream_common< C, T >::close [inline]
Close the pipe, returning the program's exit status, as pclose(3) does.

Calls rdbuf->close() and sets failbit on error. Returns process's exit status, as pclose(3) does.

  template<typename C , typename T > const std::string & redi::pstream_common< C, T >::command [inline]

Return the command used to initialise the stream.

Returns
    a string containing the command used to initialise the stream.

  template<typename C , typename T > void redi::pstream_common< C, T >::do_open (const std::string & cmd, pmode mode) [inline], [protected]

Start a process. Calls rdbuf()->open( command , mode ) and sets failbit on error.

Parameters
    cmd a string containing a shell command.
    mode the I/O mode to use when opening the pipe.

See also
    basic_pstreambuf::open(const std::string&, pmode)

Referenced by redi::pstream_common< CharT, Traits >::pstream_common().

  template<typename C , typename T > void redi::pstream_common< C, T >::do_open (const std::string & file, const argv_type & argv, pmode mode) [inline], [protected]

Start a process. Calls rdbuf()->open( file, argv, mode ) and sets failbit on error.

Parameters
    file a string containing the pathname of a program to execute.
    argv a vector of argument strings passed to the new program.
    mode the I/O mode to use when opening the pipe.

See also
    basic_pstreambuf::open(const std::string&, const argv_type&, pmode)

  template<typename C , typename T > bool redi::pstream_common< C, T >::is_open [inline]

Report whether the stream's buffer has been initialised.

Returns
    rdbuf()->is_open().

See also
    basic_pstreambuf::is_open()

  template<typename C , typename T > pstream_common< C, T >::streambuf_type * redi::pstream_common< C, T >::rdbuf [inline]

Return a pointer to the stream buffer.

Returns
    a pointer to the private stream buffer member.

Author

Generated automatically by Doxygen for PStreams from the source code.